<?php defined('C5_EXECUTE') or die("Access Denied.");

/**
 * ab_coupon package for Concrete5
 * Copyright Copyright 2017-2019, Alex Borisov
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author Alex Borisov <linuxoidoz@gmail.com>
 * @package Concrete\Package\ab_coupon
 */

$al = $app->make('helper/concrete/asset_library');
$editor = $app->make('editor');

?>

<style>
.ab-coupon-form .text-muted {
    font-size: 0.8em;
}
</style>

<fieldset class="ab-coupon-form">

    <div class="col-xs-12">
        <div class="form-group">
            <div class="checkbox" data-checkbox-wrapper="show_picture">
                <label>
                    <?php
                    echo $form->checkbox('show_picture', 1, $show_picture);
                    echo t('Show picture?');
                    ?>
                </label>
            </div>
            <div data-fields="show_picture" style="display: none">
                <div class="well">
                    <div class="form-group">
                        <?php
                        echo $form->label('picture', t('Picture'));
                        echo $al->image('picture', 'pictureID', t('Choose picture'), $pic);
                        ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
    
    <div class="col-xs-12">
        <div class="form-group">
            <?php
            echo $form->label('primary_title', t('Primary title'));
            echo $form->text('primary_title', $primary_title, ['maxlength' => 200]);
            echo '<p class="text-muted">' . t('Max 200 symbols') . '</p>';
            ?>
        </div>
    </div>

    <div class="col-xs-12">
        <div class="form-group">
            <?php
            echo $form->label('secondary_title', t('Secondary title'));
            echo $form->text('secondary_title', $secondary_title, ['maxlength' => 200]);
            echo '<p class="text-muted">' . t('Max 200 symbols') . '</p>';
            ?>
        </div>
    </div>

    <div class="col-xs-12">
        <div class="form-group">
            <div class="checkbox" data-checkbox-wrapper="show_sale">
                <label>
                    <?php
                    echo $form->checkbox('show_sale', 1, $show_sale);
                    echo t('Show sale info?');
                    ?>
                </label>
            </div>
        </div>
        <div data-fields="show_sale" style="display: none">
            <div class="col-xs-4">
                <div class="form-group">
                    <?php
                    echo $form->label('price_before', t('Price before'));
                    echo $form->text('price_before', $price_before ? $price_before : '', ['maxlength' => 20, 'class' => "decimals"]);
                    echo '<p class="text-muted">' . t('Max 20 symbols') . '</p>';
                    ?>
                </div>
            </div>
            <div class="col-xs-4">
                <div class="form-group">
                    <?php
                    echo $form->label('price_after', t('Price after'));
                    echo $form->text('price_after', $price_after ? $price_after : '', ['maxlength' => 20, 'class' => "decimals"]);
                    echo '<p class="text-muted">' . t('Max 20 symbols') . '</p>';
                    ?>
                </div>
            </div>
            <div class="col-xs-4">
                <div class="form-group">
                    <?php
                    echo $form->label('currency_symbol', t('Currency symbol'));
                    echo $form->text('currency_symbol', $currency_symbol ? $currency_symbol : '$', ['maxlength' => 3]);
                    echo '<p class="text-muted">' . t('Max 3 symbols') . '</p>';
                    ?>
                </div>
            </div>
            <div class="col-xs-12">
                <div class="form-group">
                    <div class="checkbox">
                        <label>
                            <?php
                            echo $form->checkbox('show_saving', 1, $show_saving);
                            echo t('Show saving info?');
                            ?>
                        </label>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="col-xs-12">
        <div class="form-group">
            <div class="checkbox" data-checkbox-wrapper="show_until">
                <label>
                    <?php
                    echo $form->checkbox('show_until', 1, $show_until);
                    echo t('Show valid until info?');
                    ?>
                </label>
            </div>
        </div>
        <div data-fields="show_until" style="display: none">
            <div class="well">
                <div class="form-group">
                    <div id="block_note" class="alert alert-info" role="alert">
                    <?php echo t('Timer input field must be in following format: YYYY-MM-DD HH:MM:SS'); ?>
                    </div>
                </div>
                <div class="form-group">
                    <?php
                    echo $form->label('valid_until', t('Valid until'));
                    echo $form->text('valid_until', $valid_until ? $valid_until : '', ['maxlength' => 20]);
                    echo '<p class="text-muted">' . t('Max 20 symbols') . '</p>';
                    ?>
                </div>
            </div>
        </div>
    </div>

    <div class="col-xs-12">
        <div class="form-group">
            <div id="block_note" class="alert alert-info" role="alert">
            <?php echo t('Text to show'); ?>
            </div>
        </div>
    </div>
    
    <div class="col-xs-12">
        <div class="form-group">
            <?php 
            echo $editor->outputBlockEditModeEditor('text_show', $controller->getTextShow());
            echo '<p class="text-muted">' . t('Max 65535 symbols') . '</p>';
            ?>
        </div>
    </div>
    
    <div class="col-xs-12">
        <div class="form-group">
            <div id="block_note" class="alert alert-info" role="alert">
            <?php echo t('Text to hide'); ?>
            </div>
        </div>
    </div>
    
    <div class="col-xs-12">
        <div class="form-group">
            <?php 
            echo $editor->outputBlockEditModeEditor('text_hide', $controller->getTextHide());
            echo '<p class="text-muted">' . t('Max 65535 symbols') . '</p>';
            ?>
        </div>
    </div>
    
    <div class="col-xs-12">
        <div class="form-group">
            <?php
            echo $form->label('btn_text', t('Show/hide button text'));
            echo $form->text('btn_text', $btn_text ? $btn_text : t('show / hide'), ['maxlength' => 100]);
            echo '<p class="text-muted">' . t('Max 100 symbols') . '</p>';
            ?>
        </div>
    </div>

    <div class="col-xs-12">
        <div class="form-group">
            <div class="checkbox">
                <label>
                    <?php
                    echo $form->checkbox('popup', 1, $popup);
                    echo t('Show hidden text in Lightbox?');
                    ?>
                </label>
            </div>
        </div>
    </div>
    
</fieldset>

<script type="text/javascript" charset="UTF-8">
$(function(){
    $('#ccm-form-submit-button').on('click', function(e){
        var primary_title = $.trim($('#primary_title').val());
        var secondary_title = $.trim($('#secondary_title').val());
        if (primary_title.length > 200 || secondary_title.length > 200) {
            e.preventDefault();  // stop form from submitting
            e.stopPropagation(); // stop anything else from listening to our event and screwing things up
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Title value error:')); ?>,
                message: <?php echo json_encode(t('Max 200 symbols')); ?>
            });
        }
        
        var valid_until = $.trim($('#valid_until').val());
        var datetime = /^(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})$/;
        if ($('#show_until').is(':checked') && (!datetime.test(valid_until) || valid_until == '')) {
            e.preventDefault();  // stop form from submitting
            e.stopPropagation(); // stop anything else from listening to our event and screwing things up
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Valid until value error:')); ?>,
                message: <?php echo json_encode(t('Valid until cannot be empty and must be in the following format: YYYY-MM-DD HH:MM:SS')); ?>
            });
        }
        else if (valid_until.length > 20) {
            e.preventDefault();  // stop form from submitting
            e.stopPropagation(); // stop anything else from listening to our event and screwing things up
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Valid until value error:')); ?>,
                message: <?php echo json_encode(t('Max 20 symbols')); ?>
            });
        }
        
        var price_before = $.trim($('#price_before').val());
        var price_after = $.trim($('#price_after').val());
        if ($('#show_sale').is(':checked') && (price_before == '' || price_after == '')) {
            e.preventDefault();  // stop form from submitting
            e.stopPropagation(); // stop anything else from listening to our event and screwing things up
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Price value error:')); ?>,
                message: <?php echo json_encode(t('Prices cannot be empty')); ?>
            });
        }
        else if ($('#show_sale').is(':checked') && (price_before.length > 20 || price_after.length > 20)) {
            e.preventDefault();  // stop form from submitting
            e.stopPropagation(); // stop anything else from listening to our event and screwing things up
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Price value error:')); ?>,
                message: <?php echo json_encode(t('Max 20 symbols')); ?>
            });
        }
        
        var currency_symbol = $.trim($('#currency_symbol').val());
        if ($('#show_sale').is(':checked') && currency_symbol.length > 3) {
            e.preventDefault();  // stop form from submitting
            e.stopPropagation(); // stop anything else from listening to our event and screwing things up
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Currency symbol value error:')); ?>,
                message: <?php echo json_encode(t('Max 3 symbols')); ?>
            });
        }
        
        var text_show = $('textarea[name=text_show]').val();
        var text_hide = $('textarea[name=text_hide]').val();
        if (text_show.length > 65535 || text_hide.length > 65535) {
            e.preventDefault();  // stop form from submitting
            e.stopPropagation(); // stop anything else from listening to our event and screwing things up
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Text show/hide value error:')); ?>,
                message: <?php echo json_encode(t('Max 65535 symbols')); ?>
            });
        }
        
        var btn_text = $.trim($('#btn_text').val());
        if (btn_text.length > 100) {
            e.preventDefault();  // stop form from submitting
            e.stopPropagation(); // stop anything else from listening to our event and screwing things up
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Button text value error:')); ?>,
                message: <?php echo json_encode(t('Max 100 symbols')); ?>
            });
        }
    });
    
    $('.decimals').keydown(function (e) {
        // Allow: backspace, delete, tab, escape, enter and .
        if ($.inArray(e.keyCode, [46, 8, 9, 27, 13, 110, 190]) !== -1 ||
             // Allow: Ctrl+A, Command+A
            (e.keyCode === 65 && (e.ctrlKey === true || e.metaKey === true)) || 
             // Allow: home, end, left, right, down, up
            (e.keyCode >= 35 && e.keyCode <= 40)) {
                 // let it happen, don't do anything
                 return;
        }
        // Ensure that it is a number and stop the keypress
        if ((e.shiftKey || (e.keyCode < 48 || e.keyCode > 57)) && (e.keyCode < 96 || e.keyCode > 105)) {
            e.preventDefault();
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Oops')); ?>,
                message: <?php echo json_encode(t('Numbers only!')); ?>
            });
        }
    });

    $('#show_picture').on('change', function() {
        $('div[data-fields=show_picture]').toggle($(this).is(':checked'));
    }).trigger('change');

    $('#show_sale').on('change', function() {
        $('div[data-fields=show_sale]').toggle($(this).is(':checked'));

        if (!$(this).is(':checked')) {
            $('#price_before').val('');
            $('#price_after').val('');
            $('#show_saving').prop('checked', false);
        }
    }).trigger('change');

    $('#show_until').on('change', function() {
        $('div[data-fields=show_until]').toggle($(this).is(':checked'));

        if (!$(this).is(':checked')) {
            $('#valid_until').val('');
        }
    }).trigger('change');

});
</script>
